VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Root"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Compare Text
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Class Root
' Author: Chip Pearson, chip@cpearson.com, www.cpearson.com
' This is the sole creatable class of the project.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Function TrimToNull(S As String) As String
    TrimToNull = modRegistryKeysAndValues.TrimToNull(S)
End Function
Public Function IsArrayAllocated(Arr As Variant) As Boolean
    IsArrayAllocated = modRegistryKeysAndValues.IsArrayAllocated(Arr)
End Function

Public Function RegistrySubKeyCount(BaseKey As Long, KeyName As String) As Long
    RegistrySubKeyCount = modRegistryKeysAndValues.RegistrySubKeyCount(BaseKey, KeyName)
End Function

Public Function RegistryValueCount(BaseKey As Long, KeyName As String) As Long
    RegistryValueCount = modRegistryKeysAndValues.RegistryValueCount(BaseKey, KeyName)
End Function

Public Function RegistryValuesOfKey(BaseKey As Long, KeyName As String) As String()
    RegistryValuesOfKey = modRegistryKeysAndValues.RegistryValuesOfKey(BaseKey, KeyName)
End Function

Public Function RegistrySubKeysOfKey(BaseKey As Long, KeyName As String) As String()
    RegistrySubKeysOfKey = modRegistryKeysAndValues.RegistrySubKeysOfKey(BaseKey, KeyName)
End Function

Public Function RegistrySubKeyNamesToArray(BaseKey As Long, KeyName As String) As Variant
    RegistrySubKeyNamesToArray = modEnumKeysAndValues.RegistrySubKeyNamesToArray(BaseKey:=BaseKey, KeyName:=KeyName)
End Function

Public Function RegistryValueNamesToArray(BaseKey As Long, KeyName As String) As Variant
    RegistryValueNamesToArray = modEnumKeysAndValues.RegistryValueNamesToArray(BaseKey:=BaseKey, KeyName:=KeyName)
End Function

Public Function RegistryNumberOfSubKeys(BaseKey As Long, KeyName As String) As Long
    RegistryNumberOfSubKeys = modEnumKeysAndValues.RegistryNumberOfSubKeys(BaseKey:=BaseKey, KeyName:=KeyName)
End Function

Public Function RegistryNumberOfValues(BaseKey As Long, KeyName As String) As Long
    RegistryNumberOfValues = modEnumKeysAndValues.RegistryNumberOfValues(BaseKey:=BaseKey, KeyName:=KeyName)
End Function

Public Function RegistryKeyExists(BaseKey As Long, KeyName As String) As Boolean
Attribute RegistryKeyExists.VB_Description = "Tests whether a Key exists."
    RegistryKeyExists = modRegistry.RegistryKeyExists(BaseKey:=BaseKey, KeyName:=KeyName)
End Function

Public Function RegistryValueExists(BaseKey As Long, KeyName As String, ValueName As String) As Boolean
Attribute RegistryValueExists.VB_Description = "Tests whether a Value exists."
    RegistryValueExists = modRegistry.RegistryValueExists(BaseKey:=BaseKey, KeyName:=KeyName, ValueName:=ValueName)
End Function

Public Function RegistryCreateKey(BaseKey As Long, KeyName As String) As Boolean
Attribute RegistryCreateKey.VB_Description = "Create a registry key."
    RegistryCreateKey = modRegistry.RegistryCreateKey(BaseKey:=BaseKey, KeyName:=KeyName)
End Function

Public Function RegistryCreateValue(BaseKey As Long, KeyName As String, _
    ValueName As String, ValueValue As Variant) As Boolean
Attribute RegistryCreateValue.VB_Description = "Creates a registry Value."
    RegistryCreateValue = modRegistry.RegistryCreateValue(BaseKey:=BaseKey, _
        KeyName:=KeyName, ValueName:=ValueName, ValueValue:=ValueValue)
End Function

    Public Function RegistryGetValue(BaseKey As Long, KeyName As String, _
        ValueName As String) As Variant
Attribute RegistryGetValue.VB_Description = "Retrieves the value of a Value."
    RegistryGetValue = modRegistry.RegistryGetValue(BaseKey:=BaseKey, KeyName:=KeyName, ValueName:=ValueName)
End Function

Public Function RegistrySetValue(BaseKey As Long, KeyName As String, _
    ValueName As String, NewValue As Variant) As Boolean
Attribute RegistrySetValue.VB_Description = "Sets the value of a Value."
    RegistrySetValue = modRegistry.RegistrySetValue(BaseKey:=BaseKey, KeyName:=KeyName, ValueName:=ValueName, NewValue:=NewValue)
End Function

Public Function RegistryDeleteKey(BaseKey As Long, KeyName As String) As Boolean
Attribute RegistryDeleteKey.VB_Description = "Deletes a key and all of its subkeys and values."
    RegistryDeleteKey = modRegistry.RegistryDeleteKey(BaseKey:=BaseKey, KeyName:=KeyName)
End Function

Public Function RegistryDeleteValue(BaseKey As Long, KeyName As String, ValueName As String) As Boolean
Attribute RegistryDeleteValue.VB_Description = "Deletes a registry Value."
    RegistryDeleteValue = modRegistry.RegistryDeleteValue(BaseKey:=BaseKey, KeyName:=KeyName, ValueName:=ValueName)
End Function


Public Property Get RegistryWorxErrorNumber() As Long
Attribute RegistryWorxErrorNumber.VB_Description = "Returns the RegistryWorx error number."
    RegistryWorxErrorNumber = G_Reg_AppErrNum
End Property

Public Property Get RegistryWorxErrorText() As String
Attribute RegistryWorxErrorText.VB_Description = "Returns the RegistryWorx error text."
    RegistryWorxErrorText = GetAppErrText(G_Reg_AppErrNum)
End Property

Public Property Get SystemErrorNumber() As Long
Attribute SystemErrorNumber.VB_Description = "Returns the Windows System error number."
    SystemErrorNumber = G_Reg_SysErrNum
End Property

Public Property Get SystemErrorText() As String
Attribute SystemErrorText.VB_Description = "Returns the Windows system error text."
    SystemErrorText = GetSystemErrorMessageText(G_Reg_SysErrNum)
End Property

Public Property Get About() As String

Dim S As String
S = "About RegistryWorx" & vbCrLf & _
    Chr(169) & " Copyright 2007, Charles H Pearson" & vbCrLf & _
    "By Chip Pearson, July, 2007" & vbCrLf & _
    "chip@cpearson.com" & vbCrLf & _
    "www.cpearson.com" & vbCrLf & _
    "RegistryWorx Page: www.cpearson.com/Excel/RegistryWorx.aspx"
About = S

End Property

Public Sub ShowAboutForm()
    frmAbout.Show vbModal
End Sub

Public Property Get Version() As String
    Version = CStr(App.Major) & "." & CStr(App.Minor) & "." & CStr(App.Revision)
End Property

Public Property Get HKCU() As Long
' read only - HKEY_CURRENT_USER
    HKCU = &H80000001
End Property

Public Property Get HKEY_CURRENT_USER() As Long
    HKEY_CURRENT_USER = Me.HKCU
End Property

Public Property Get HKLM() As Long
' read only - HKEY_LOCAL_MACHINE
    HKLM = &H80000002
End Property

Public Property Get HKEY_LOCAL_MACHINE() As Long
    HKEY_LOCAL_MACHINE = Me.HKLM
End Property

Public Property Get HKCR() As Long
' read-only - HKEY_CLASSES_ROOT
    HKCR = &H80000000
End Property

Public Property Get HKEY_CLASSES_ROOT() As Long
    HKEY_CLASSES_ROOT = Me.HKCR
End Property

